//+------------------------------------------------------------------+
//|                                                                  |
//|                 Copyright  1999-2008, MetaQuotes Software Corp. |
//|                                         http://www.metaquotes.ru |
//+------------------------------------------------------------------+

//---- indicator settings

#property  indicator_chart_window
#property  indicator_buffers 0
//----

//---- indicator parameters

extern string          help                     = "bars forward positions Level Line";
extern double          bars_forward             = 1;      //Time[0] + numberOfSecondsIntoTheFuture is Time[0]+q*Period()*60; // q bars into the future
extern double          BoxLength                = 3;      // sets length of Level Line
extern string          label_adjust_help        = "For Forex *10E-5";
extern double          LabelAdjHorizontal       = 2;      // positions label above or under shaded box depicting spread   
extern double          AskLabelAdjUp            = 0.3;    //
extern double          BidLabelAdjDown          = 0;      //
extern int             font_size                = 8;      // sets font size
extern string          help1                    = "set to true to show box";
extern bool            ShowBox                  = true;   // set true to display box
extern bool            ShowLabel                = true;   // set true to display label


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
   {
   IndicatorShortName("Bid-Ask Spread");
   
   
   //---- initialization done
   return(0);
   }    
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
   {
    ObjectDelete("Box");
    ObjectDelete("Box_label");
    ObjectDelete("Box_label2");         
   return(0);
   }
//+------------------------------------------------------------------+
//| Other timeframe line levels                                           |
//+------------------------------------------------------------------+
int start()
       
       {
       
//-
//-----Draw Box Rectangle");
//--
       if (ShowBox) // draw if true
       {
       if (ObjectFind   ("Box") == -1) 
           ObjectCreate ("Box", OBJ_RECTANGLE, 0, 0, 0, 0, 0);
         
           ObjectSet    ("Box", OBJPROP_TIME1,       Time[0] +             bars_forward * 60 * Period() );
           ObjectSet    ("Box", OBJPROP_TIME2,       Time[0] + BoxLength * bars_forward * 60 * Period() );
      
           ObjectSet    ("Box", OBJPROP_PRICE1,      Ask );
           ObjectSet    ("Box", OBJPROP_PRICE2,      Bid );
      
           ObjectSet    ("Box", OBJPROP_RAY,         false);
           ObjectSet    ("Box", OBJPROP_COLOR,       PeachPuff);
           ObjectSet    ("Box", OBJPROP_WIDTH,       3);
       }
  //-- Draw Box Label -----------------------------------------      
       if (ShowBox) // draw if true
       {
       if (ObjectFind   ("Box_label") == -1) 
           ObjectCreate ("Box_label", OBJ_TEXT, 0, 0, 0);
      
           ObjectSet    ("Box_label", OBJPROP_TIME1, Time[0] + LabelAdjHorizontal *bars_forward * 60 * Period() );
           ObjectSet    ("Box_label", OBJPROP_PRICE1, (Ask+AskLabelAdjUp) );

           ObjectSet    ("Box_label", OBJPROP_COLOR, Black);
           ObjectSetText("Box_label", "Ask", font_size, "Arial", Black); 
       }
       
  //-- Draw Box Label2 -----------------------------------------      
       if (ShowBox) // draw if true
       {
       if (ObjectFind   ("Box_label2") == -1) 
           ObjectCreate ("Box_label2", OBJ_TEXT, 0, 0, 0);
      
           ObjectSet    ("Box_label2", OBJPROP_TIME1, Time[0] + LabelAdjHorizontal *bars_forward * 60 * Period() );
           ObjectSet    ("Box_label2", OBJPROP_PRICE1,( Bid-BidLabelAdjDown) );

           ObjectSet    ("Box_label2", OBJPROP_COLOR, Black);
           ObjectSetText("Box_label2", "Bid", font_size, "Arial", Black); 
       }     
       
  
   //----
   return(0);
   }
//+------------------------------------------------------------------+